#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "DuiDefine.h"

class EmbeddedDUIInMFCWindow;
typedef EmbeddedDUIInMFCWindow EDIMWindow;

class EmbeddedDUIInMFCWindow : public WindowImplBase
{
public:
	EmbeddedDUIInMFCWindow(CWnd* pParent)
	{
		m_pParent = pParent;
		m_pSupperClassWinodw = new CWnd();
		Embed();
	}

	virtual ~EmbeddedDUIInMFCWindow()
	{
		if(m_pSupperClassWinodw != NULL)
		{
			delete m_pSupperClassWinodw;
			m_pSupperClassWinodw = NULL;
		}
	}

	UINT CalcWindowId()
	{
		std::list<UINT> listChildWinIds = GetAllChildWindowIds(m_pParent->GetSafeHwnd());
		if(0 == listChildWinIds.size())
		{
			return EDIM_BASE_WINDOW_ID;
		}
		listChildWinIds.sort();
		UINT uId = *listChildWinIds.rbegin();
		uId++;

		if(uId < EDIM_BASE_WINDOW_ID)
		{
			uId = EDIM_BASE_WINDOW_ID;
		}

		return uId;
		
	}
	void Embed()
	{
		if(m_pSupperClassWinodw != NULL)
		{
			UINT uId = CalcWindowId();
			m_pSupperClassWinodw->Create(NULL, NULL, WS_VISIBLE|WS_CHILD, CRect(0,0,0,0), m_pParent, uId);
			if(::IsWindow(m_pSupperClassWinodw->GetSafeHwnd()))
			{
				Subclass(m_pSupperClassWinodw->GetSafeHwnd());
			}
		}
	}

protected:
	enum{EDIM_BASE_WINDOW_ID = 100000 };

	CWnd* m_pParent;

private:
	std::list<UINT> GetAllChildWindowIds(HWND hWndParent)
	{
		std::list<UINT> listWinIds;
		BOOL bEffectWindow = ::IsWindow(hWndParent);
		ASSERT(bEffectWindow);
		if(!bEffectWindow)
		{
			return listWinIds;
		}

		HWND hWnd = GetWindow(hWndParent, GW_CHILD);
		while(hWnd != NULL)
		{
			UINT uId = ::GetWindowLong(hWnd, GWL_ID);
			listWinIds.push_back(uId);
			hWnd = ::GetWindow(hWnd, GW_HWNDNEXT);
		}

		return listWinIds;
	}
	CWnd* m_pSupperClassWinodw;
	
};